% clc
% clear
load w10; w=w10;
M = length(w);
w = sqrt(M)*w/norm(w);

C=-roots(w);
Mean1 = mean(abs(C))
L = length(C);
[Csort, Psort] = sort( abs( (abs(C)- mean(abs(C))) ) );
C = flipud( C(Psort) );
Mean2 = mean(abs(C))
C1 = C;
abs(C1)
Mean3 = mean(abs(C1))
W = [w flipud(conj(w))]        % Set of all possible Beamforming Vectors is stored in W
Lreduced = 5;   % Number of largest roots in magnitude
for k=1:(2^Lreduced)-1
    str = dec2bin(k, Lreduced);
    for l=1:Lreduced
        if str(l) == '0'
            C1(l)=C(l);
        else
            C1(l)=1/conj(C(l));
        end
    end
    AA1=[1,C1(1)];
    for k=2:L;
        AA1=conv(AA1,[1,C1(k)]);
    end
    
    BB1=[1,1/conj(C1(1))]*conj(C1(1));
    for k=2:L;
        BB1=conv(BB1,[1,1/conj(C1(k))])*conj(C1(k));
    end
    
    wnew=AA1.'./norm(AA1)*norm(w);
    W=[W wnew flipud(conj(wnew))];
end


% Number of Columns
count=0;
AvgPow = mean(abs(w).^2);
S=max( abs( (abs(w).^2 - AvgPow ) ) );%/min(abs(w));
[K1, K2] = size(W)
tic
for n1=1:K2
    n1
    for n2=n1:K2
        wsel1=W(:,n1);
        wsel2=W(:,n2);
        Wsel=[wsel1 wsel2]/sqrt(2);
        % disp(max(mean(abs(Wsel).^2)')/min(mean(abs(Wsel).^2)'))
        count=count+1;
        aaa(count)=max( abs(sum(abs(Wsel.').^2) - AvgPow) );
        if ( aaa(count) < S)
            Wfound=Wsel;
            S = aaa(count);
        end
    end
end
toc
TotalPower1 =  sum(diag(w*w'))
TotalPower2 =  sum(diag(Wfound*Wfound'))
MaxDeviation = max( abs(sum(abs(Wfound.').^2) - AvgPow) )
%
disp(max(abs(w).^2)/mean(abs(w).^2));
disp(max(sum(abs(Wfound.').^2))/mean(sum(abs(Wfound.').^2)))
%
% figure
% plot(abs(w).^2); grid
% hold on
% plot(sum((abs(Wfound).^2).'),'r');
%
figure
plot( 10*log10(abs(w).^2), '-hr'); grid
hold on
plot( 10*log10(sum((abs(Wfound).^2).') ), '-o');
%
% figure
% counter=0;
% for theta = -pi/2:.01:pi/2
%     counter=counter+1;
%     aaa=exp(-j*pi*[0:L]'*sin(theta));
%     gridd(counter)=theta;
%     ssss1(counter)=aaa'*w*w'*aaa;
%     ssss2(counter)=aaa'*Wfound*Wfound'*aaa;
%     
% end
% 
% plot(gridd,10*log10(ssss1)); grid
% hold on
% plot(gridd,10*log10(ssss2),'r--');
% 
